=== debian/changelog ===
loopino (0.5.0-0ubuntu1) resolute; urgency=medium

  * Initial release. (LP: #2137383)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Fri, 02 Jan 2026 17:22:06 -0800
