=== debian/control ===
Source: loopino
Section: sound
Priority: optional
Maintainer: Erich Eickmeyer <eeickmeyer@ubuntu.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 libsndfile1-dev,
 libfftw3-dev,
 libcairo2-dev,
 libx11-dev,
 librubberband-dev,
 libjack2-dev | libjack-dev,
 libasound2-dev,
 pkgconf
Standards-Version: 4.7.2
Homepage: https://github.com/brummer10/Loopino

Package: loopino
Architecture: all
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 loopino-standalone,
 loopino-vst2,
 loopino-clap
Description: Lightweight audio sampler (Metapackage)
 Loopino is a lightweight audio sampler. It allows you to load, trim, and loop
 audio files with precision, making it ideal for crafting seamless sample
 loops. With a clean, minimal interface, Loopino fits perfectly into any audio
 workflow — whether for sound design, live performance, or creative sampling
 experiments.
 .
 This is a metapackage that installs all Loopino variants: standalone
 application, VST2 plugin, and CLAP plugin. If you only need a specific
 variant, consider installing the corresponding package directly
 (loopino-standalone, loopino-vst2, or loopino-clap).

Package: loopino-standalone
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Lightweight audio sampler (Standalone Application)
 Loopino is a lightweight audio sampler. It allows you to load, trim, and loop
 audio files with precision, making it ideal for crafting seamless sample
 loops. With a clean, minimal interface, Loopino fits perfectly into any audio
 workflow — whether for sound design, live performance, or creative sampling
 experiments.
 .
 This package provides the Loopino standalone application.

Package: loopino-vst
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Lightweight audio sampler (VST2 Plugin)
 Loopino is a lightweight audio sampler. It allows you to load, trim, and loop
 audio files with precision, making it ideal for crafting seamless sample
 loops. With a clean, minimal interface, Loopino fits perfectly into any audio
 workflow — whether for sound design, live performance, or creative sampling
 experiments.
 .
 This package provides the Loopino VST2 plugin.

Package: loopino-clap
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Lightweight audio sampler (CLAP Plugin)
 Loopino is a lightweight audio sampler. It allows you to load, trim, and loop
 audio files with precision, making it ideal for crafting seamless sample
 loops. With a clean, minimal interface, Loopino fits perfectly into any audio
 workflow — whether for sound design, live performance, or creative sampling
 experiments.
 .
 This package provides the Loopino CLAP plugin.
