=== debian/watch ===
Version: 5
Source: https://api.github.com/repos/brummer10/Loopino/releases?per_page=100
Matching-Pattern: https://github.com/brummer10/Loopino/releases/download/v[^/]+/Loopino-v@ANY_VERSION@-src\.tar\.xz
Filename-Mangle: s%.*/Loopino-v@ANY_VERSION@-src\.tar\.xz%loopino-$1.tar.xz%
Search-Mode: plain
